/* libgda-3.0.vapi generated by vapigen, do not modify. */

[CCode (cprefix = "Gda", lower_case_cprefix = "gda_")]
namespace Gda {
	[Compact]
	[CCode (copy_function = "gda_binary_copy", cheader_filename = "libgda-3.0.h")]
	public class Binary {
		public long binary_length;
		[CCode (array_length = false)]
		public weak uchar[] data;
		public static void* copy (void* boxed);
		public unowned string to_string (uint maxlen);
	}
	[Compact]
	[CCode (copy_function = "gda_blob_copy", cheader_filename = "libgda-3.0.h")]
	public class Blob {
		public weak Gda.Binary data;
		public weak Gda.BlobOp op;
		public static void* copy (void* boxed);
		public void set_op (Gda.BlobOp op);
		public unowned string to_string (uint maxlen);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class BlobOp : GLib.Object {
		public virtual long get_length ();
		public virtual long read (Gda.Blob blob, long offset, long size);
		public bool read_all (Gda.Blob blob);
		public virtual long write (Gda.Blob blob, long offset);
		public virtual bool write_all (Gda.Blob blob);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Client : GLib.Object {
		public bool begin_transaction (string name, Gda.TransactionIsolation level) throws GLib.Error;
		public void close_all_connections ();
		public bool commit_transaction (string name) throws GLib.Error;
		public void declare_connection (Gda.Connection cnc);
		public static GLib.Quark error_quark ();
		public unowned Gda.Connection find_connection (string dsn, string username, string password);
		public unowned GLib.List get_connections ();
		public unowned string get_dsn_specs (string provider);
		[CCode (has_construct_function = false)]
		public Client ();
		public void notify_connection_closed_event (Gda.Connection cnc);
		public void notify_connection_opened_event (Gda.Connection cnc);
		public void notify_error_event (Gda.Connection cnc, Gda.ConnectionEvent error);
		public void notify_event (Gda.Connection cnc, Gda.ClientEvent event, Gda.ParameterList params);
		public unowned Gda.Connection open_connection (string dsn, string username, string password, Gda.ConnectionOptions options) throws GLib.Error;
		public unowned Gda.Connection open_connection_from_string (string provider_id, string cnc_string, string username, string password, Gda.ConnectionOptions options) throws GLib.Error;
		public bool perform_create_database (Gda.ServerOperation op) throws GLib.Error;
		public bool perform_drop_database (Gda.ServerOperation op) throws GLib.Error;
		public unowned Gda.ServerOperation prepare_create_database (string db_name, string provider);
		public unowned Gda.ServerOperation prepare_drop_database (string db_name, string provider);
		public bool rollback_transaction (string name) throws GLib.Error;
		public virtual signal void event_notification (Gda.Connection cnc, Gda.ClientEvent event, Gda.ParameterList params);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Column : GLib.Object {
		public unowned Gda.Column copy ();
		public bool get_allow_null ();
		public bool get_auto_increment ();
		public unowned string get_caption ();
		public unowned string get_dbms_type ();
		public GLib.Value get_default_value ();
		public long get_defined_size ();
		public GLib.Type get_g_type ();
		public unowned string get_name ();
		public int get_position ();
		public bool get_primary_key ();
		public unowned string get_references ();
		public long get_scale ();
		public unowned string get_table ();
		public unowned string get_title ();
		public bool get_unique_key ();
		[CCode (has_construct_function = false)]
		public Column ();
		public void set_allow_null (bool allow);
		public void set_auto_increment (bool is_auto);
		public void set_caption (string caption);
		public void set_dbms_type (string dbms_type);
		public void set_default_value (GLib.Value default_value);
		public void set_defined_size (long size);
		public void set_g_type (GLib.Type type);
		public void set_name (string name);
		public void set_position (int position);
		public void set_primary_key (bool pk);
		public void set_references (string @ref);
		public void set_scale (long scale);
		public void set_table (string table);
		public void set_title (string title);
		public void set_unique_key (bool uk);
		[NoAccessorMethod]
		public string id { owned get; set; }
		public virtual signal void g_type_changed (int old_type, int new_type);
		public virtual signal void name_changed (string old_name);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ColumnIndex : GLib.Object {
		public unowned Gda.ColumnIndex copy ();
		public bool equal (Gda.ColumnIndex rhs);
		public unowned string get_column_name ();
		public long get_defined_size ();
		public unowned string get_references ();
		public Gda.Sorting get_sorting ();
		[CCode (has_construct_function = false)]
		public ColumnIndex ();
		public void set_column_name (string column_name);
		public void set_defined_size (long size);
		public void set_references (string @ref);
		public void set_sorting (Gda.Sorting sorting);
	}
	[Compact]
	[CCode (copy_function = "gda_command_copy", cheader_filename = "libgda-3.0.h")]
	public class Command {
		public Gda.CommandOptions options;
		public weak string text;
		public Gda.CommandType type;
		public unowned Gda.Command copy ();
		public Gda.CommandType get_command_type ();
		public Gda.CommandOptions get_options ();
		public unowned string get_text ();
		[CCode (has_construct_function = false)]
		public Command (string text, Gda.CommandType type, Gda.CommandOptions options);
		public void set_command_type (Gda.CommandType type);
		public void set_options (Gda.CommandOptions options);
		public void set_text (string text);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Connection : GLib.Object {
		public void add_event (Gda.ConnectionEvent event);
		public unowned Gda.ConnectionEvent add_event_string (string str);
		public void add_events_list (GLib.List events_list);
		public bool add_savepoint (string name) throws GLib.Error;
		public bool begin_transaction (string name, Gda.TransactionIsolation level) throws GLib.Error;
		public bool change_database (string name);
		public void clear_events_list ();
		public void close ();
		public void close_no_warning ();
		public bool commit_transaction (string name) throws GLib.Error;
		public bool delete_savepoint (string name) throws GLib.Error;
		public static GLib.Quark error_quark ();
		public unowned GLib.List execute_command (Gda.Command cmd, Gda.ParameterList params) throws GLib.Error;
		public int execute_non_select_command (Gda.Command cmd, Gda.ParameterList params) throws GLib.Error;
		public unowned Gda.DataModel execute_select_command (Gda.Command cmd, Gda.ParameterList params) throws GLib.Error;
		public unowned Gda.Client get_client ();
		public unowned string get_cnc_string ();
		public unowned string get_database ();
		public unowned string get_dsn ();
		public unowned GLib.List get_events ();
		public unowned Gda.ServerProviderInfo get_infos ();
		public unowned string get_last_insert_id (Gda.DataModel recset);
		public Gda.ConnectionOptions get_options ();
		public unowned string get_password ();
		public unowned string get_provider ();
		public unowned Gda.ServerProvider get_provider_obj ();
		public unowned Gda.DataModel get_schema (Gda.ConnectionSchema schema, Gda.ParameterList params) throws GLib.Error;
		public unowned string get_server_version ();
		public unowned Gda.TransactionStatus get_transaction_status ();
		public unowned string get_username ();
		public void internal_change_transaction_state (Gda.TransactionStatusState newstate);
		public void internal_savepoint_added (string parent_trans, string svp_name);
		public void internal_savepoint_removed (string svp_name);
		public void internal_savepoint_rolledback (string svp_name);
		public void internal_sql_executed (string sql, Gda.ConnectionEvent error);
		public void internal_transaction_committed (string trans_name);
		public void internal_transaction_rolledback (string trans_name);
		public void internal_transaction_started (string parent_trans, string trans_name, Gda.TransactionIsolation isol_level);
		public void internal_treat_sql (string sql, Gda.ConnectionEvent error);
		public bool is_opened ();
		[CCode (has_construct_function = false)]
		public Connection (Gda.Client client, Gda.ServerProvider provider, string dsn, string username, string password, Gda.ConnectionOptions options);
		public bool open () throws GLib.Error;
		public bool rollback_savepoint (string name) throws GLib.Error;
		public bool rollback_transaction (string name) throws GLib.Error;
		public bool set_dsn (string datasource);
		public bool set_password (string password);
		public bool set_username (string username);
		public bool supports_feature (Gda.ConnectionFeature feature);
		public unowned string value_to_sql_string (GLib.Value from);
		[NoAccessorMethod]
		public Gda.Client client { owned get; set; }
		[NoAccessorMethod]
		public string cnc_string { owned get; set; }
		public string dsn { get; set; }
		[NoAccessorMethod]
		public Gda.ConnectionOptions options { get; set; }
		public string password { get; set; }
		[NoAccessorMethod]
		public Gda.ServerProvider provider_obj { owned get; set; }
		public string username { get; set; }
		public virtual signal void conn_closed ();
		public virtual signal void conn_opened ();
		public virtual signal void conn_to_close ();
		public virtual signal void dsn_changed ();
		public virtual signal void error (Gda.ConnectionEvent error);
		public virtual signal void transaction_status_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ConnectionEvent : GLib.Object {
		public void free ();
		public long get_code ();
		public unowned string get_description ();
		public Gda.ConnectionEventType get_event_type ();
		public Gda.ConnectionEventCode get_gda_code ();
		public unowned string get_source ();
		public unowned string get_sqlstate ();
		public static unowned GLib.List list_copy (GLib.List events);
		public static void list_free (GLib.List events);
		[CCode (has_construct_function = false)]
		public ConnectionEvent (Gda.ConnectionEventType type);
		public void set_code (long code);
		public void set_description (string description);
		public void set_event_type (Gda.ConnectionEventType type);
		public void set_gda_code (Gda.ConnectionEventCode code);
		public void set_source (string source);
		public void set_sqlstate (string sqlstate);
		[NoAccessorMethod]
		public int type { get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataAccessWrapper : Gda.Object, Gda.DataModel {
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataAccessWrapper (Gda.DataModel model);
		public bool row_exists (int row);
		[NoAccessorMethod]
		public Gda.DataModel model { owned get; construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelArray : Gda.DataModelRow, Gda.DataModel {
		public void clear ();
		public static unowned Gda.DataModel copy_model (Gda.DataModel src) throws GLib.Error;
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelArray (int cols);
		public void set_n_columns (int cols);
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelArray.with_g_types (int cols);
		[NoAccessorMethod]
		public uint n_columns { get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelFilterSQL : Gda.DataModelArray, Gda.DataModel {
		public void add_source (string name, Gda.DataModel source);
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelFilterSQL ();
		public bool run ();
		public void set_sql (string sql);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelHash : Gda.DataModelRow, Gda.DataModel {
		public void clear ();
		public void insert_row (int rownum, Gda.Row row);
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelHash (int cols);
		public void set_n_columns (int cols);
		[NoAccessorMethod]
		public uint n_columns { get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelImport : Gda.Object, Gda.DataModel {
		public void clean_errors ();
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelImport.file (string filename, bool random_access, Gda.ParameterList options);
		public static bool from_file (Gda.DataModel model, string file, GLib.HashTable cols_trans, Gda.ParameterList options) throws GLib.Error;
		public static bool from_model (Gda.DataModel to, Gda.DataModel from, bool overwrite, GLib.HashTable cols_trans) throws GLib.Error;
		public static bool from_string (Gda.DataModel model, string str, GLib.HashTable cols_trans, Gda.ParameterList options) throws GLib.Error;
		[CCode (cname = "gda_data_model_import_new_xml_node", type = "GdaDataModel*", has_construct_function = false)]
		public DataModelImport.from_xml_node (Xml.Node node);
		public unowned GLib.SList get_errors ();
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelImport.mem (string data, bool random_access, Gda.ParameterList options);
		[NoAccessorMethod]
		public string data_string { owned get; construct; }
		[NoAccessorMethod]
		public string filename { owned get; construct; }
		[NoAccessorMethod]
		public Gda.ParameterList options { owned get; construct; }
		[NoAccessorMethod]
		public bool random_access { get; construct; }
		[NoAccessorMethod]
		public void* xml_node { get; construct; }
	}
	[Compact]
	[CCode (copy_function = "gda_data_model_index_copy", cheader_filename = "libgda-3.0.h")]
	public class DataModelIndex {
		public weak GLib.List col_idx_list;
		public weak string name;
		public bool primary_key;
		public weak string references;
		public weak string table_name;
		public bool unique_key;
		public unowned Gda.DataModelIndex copy ();
		public bool equal (Gda.DataModelIndex rhs);
		public unowned GLib.List get_column_index_list ();
		public unowned string get_name ();
		public bool get_primary_key ();
		public unowned string get_references ();
		public unowned string get_table_name ();
		public bool get_unique_key ();
		[CCode (has_construct_function = false)]
		public DataModelIndex ();
		public void set_column_index_list (GLib.List col_idx_list);
		public void set_name (string name);
		public void set_primary_key (bool pk);
		public void set_references (string @ref);
		public void set_table_name (string name);
		public void set_unique_key (bool uk);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelIter : Gda.ParameterList {
		public bool can_be_moved ();
		public static GLib.Quark error_quark ();
		public int get_column_for_param (Gda.Parameter param);
		public unowned Gda.Parameter get_param_for_column (int col);
		public int get_row ();
		public void invalidate_contents ();
		public bool is_valid ();
		public bool move_next ();
		public bool move_prev ();
		[CCode (has_construct_function = false)]
		public DataModelIter (Gda.DataModel model);
		public bool set_at_row (int row);
		[NoAccessorMethod]
		public int current_row { get; set; }
		[NoAccessorMethod]
		public Gda.DataModel data_model { owned get; construct; }
		[NoAccessorMethod]
		public Gda.DataModel forced_model { owned get; set; }
		[NoAccessorMethod]
		public bool update_model { get; set; }
		public virtual signal void end_of_data ();
		public virtual signal void row_changed (int row);
		public virtual signal bool row_to_change (int row);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelQuery : Gda.Object, Gda.DataModel {
		public bool compute_modification_queries (string target, Gda.DataModelQueryOptions options) throws GLib.Error;
		public static GLib.Quark error_quark ();
		public unowned Gda.ParameterList get_parameter_list ();
		[CCode (type = "GdaDataModel*", has_construct_function = false)]
		public DataModelQuery (Gda.Query query);
		public bool refresh () throws GLib.Error;
		public bool set_modification_query (string query) throws GLib.Error;
		[NoAccessorMethod]
		public Gda.Query delete_query { owned get; set; }
		[NoAccessorMethod]
		public Gda.Query insert_query { owned get; set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
		[NoAccessorMethod]
		public Gda.Query update_query { owned get; set; }
		[NoAccessorMethod]
		public bool use_transaction { get; set construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataModelRow : Gda.Object, Gda.DataModel {
		[NoWrapper]
		public virtual bool append_row (Gda.Row row) throws GLib.Error;
		[NoWrapper]
		public virtual unowned Gda.Row append_values (GLib.List values) throws GLib.Error;
		[NoWrapper]
		public virtual int get_n_columns ();
		[NoWrapper]
		public virtual int get_n_rows ();
		public virtual unowned Gda.Row get_row (int row) throws GLib.Error;
		[NoWrapper]
		public virtual GLib.Value get_value_at (int col, int row);
		public static void inserted (Gda.DataModel model, int row);
		[NoWrapper]
		public virtual bool is_updatable ();
		[NoWrapper]
		public virtual bool remove_row (Gda.Row row) throws GLib.Error;
		public static void removed (Gda.DataModel model, int row);
		[NoWrapper]
		public virtual bool update_row (Gda.Row row) throws GLib.Error;
		public static void updated (Gda.DataModel model, int row);
		[NoAccessorMethod]
		public string command_text { owned get; set; }
		[NoAccessorMethod]
		public int command_type { get; set; }
		[NoAccessorMethod]
		public bool read_only { get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DataProxy : Gda.Object, Gda.DataModel {
		public void alter_value_attributes (int proxy_row, int col, Gda.ValueAttribute alter_flags);
		public bool apply_all_changes () throws GLib.Error;
		public bool apply_row_changes (int proxy_row) throws GLib.Error;
		public bool cancel_all_changes ();
		public void cancel_row_changes (int proxy_row, int col);
		public void @delete (int proxy_row);
		public static GLib.Quark error_quark ();
		public int find_row_from_values (GLib.SList values, int cols_index);
		public int get_n_modified_rows ();
		public int get_n_new_rows ();
		public unowned Gda.DataModel get_proxied_model ();
		public int get_proxied_model_n_cols ();
		public int get_proxied_model_n_rows ();
		public int get_proxied_model_row (int proxy_row);
		public int get_sample_end ();
		public int get_sample_size ();
		public int get_sample_start ();
		public Gda.ValueAttribute get_value_attributes (int proxy_row, int col);
		public unowned GLib.SList get_values (int proxy_row, int cols_index, int n_cols);
		public bool has_changed ();
		public bool is_read_only ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public DataProxy (Gda.DataModel model);
		public bool row_has_changed (int proxy_row);
		public bool row_is_deleted (int proxy_row);
		public bool row_is_inserted (int proxy_row);
		public void set_sample_size (int sample_size);
		public void set_sample_start (int sample_start);
		public void undelete (int proxy_row);
		[NoAccessorMethod]
		public Gda.DataModel model { owned get; set construct; }
		[NoAccessorMethod]
		public bool prepend_null_entry { get; set; }
		public virtual signal void post_changes_applied (int row, int proxied_row);
		public virtual signal bool pre_changes_applied (int row, int proxied_row);
		public virtual signal void row_delete_changed (int row, bool to_be_deleted);
		public virtual signal void sample_changed (int sample_start, int sample_end);
		public virtual signal void sample_size_changed (int sample_size);
	}
	[Compact]
	[CCode (copy_function = "gda_data_source_info_copy", cheader_filename = "libgda-3.0.h")]
	public class DataSourceInfo {
		public weak string cnc_string;
		public weak string description;
		public bool is_global;
		public weak string name;
		public weak string password;
		public weak string provider;
		public weak string username;
		public unowned Gda.DataSourceInfo copy ();
		public bool equal (Gda.DataSourceInfo info2);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Dict : GLib.Object {
		public void assume_object (Gda.Object object);
		public void assume_object_as (Gda.Object object, GLib.Type as_type);
		public static void class_always_register (Gda.DictRegFunc func);
		public unowned string compute_xml_filename (string datasource, string app_id) throws GLib.Error;
		public void declare_object (Gda.Object object);
		public void declare_object_as (Gda.Object object, GLib.Type as_type);
		public void declare_object_string_id_change (Gda.Object obj, string oldid);
		public static GLib.Quark error_quark ();
		public void extend_with_functions ();
		public unowned Gda.Connection get_connection ();
		public unowned Gda.DictDatabase get_database ();
		public unowned Gda.DataHandler get_default_handler (GLib.Type for_type);
		public unowned Gda.DataHandler get_handler (GLib.Type for_type);
		public unowned Gda.Object get_object_by_name (GLib.Type type, string name);
		public unowned Gda.Object get_object_by_string_id (string strid);
		public unowned Gda.Object get_object_by_xml_id (GLib.Type type, string xml_id);
		public unowned Gda.DictRegisterStruct get_object_type_registration (GLib.Type type);
		public unowned GLib.SList get_objects (GLib.Type type);
		public unowned string get_xml_filename ();
		public bool load () throws GLib.Error;
		public bool load_xml_file (string xmlfile) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public Dict ();
		public bool object_is_assumed (Gda.Object object);
		public void register_object_type (Gda.DictRegisterStruct reg);
		public bool save () throws GLib.Error;
		public bool save_xml_file (string xmlfile) throws GLib.Error;
		public void set_connection (Gda.Connection cnc);
		public void set_xml_filename (string xmlfile);
		public void stop_update_dbms_meta_data ();
		public void unassume_object (Gda.Object object);
		public bool update_dbms_meta_data (GLib.Type limit_to_type, string limit_obj_name) throws GLib.Error;
		[NoAccessorMethod]
		public string dsn { owned get; set; }
		[NoAccessorMethod]
		public string username { owned get; set; }
		public virtual signal void changed ();
		public virtual signal void data_update_finished ();
		public virtual signal void data_update_started ();
		public virtual signal void object_act_changed (Gda.Object obj);
		public virtual signal void object_added (Gda.Object obj);
		public virtual signal void object_removed (Gda.Object obj);
		public virtual signal void object_updated (Gda.Object obj);
		public virtual signal void update_progress (string msg, uint now, uint total);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictAggregate : Gda.Object, Gda.XmlStorage {
		public static GLib.Quark error_quark ();
		public unowned Gda.DictType get_arg_dict_type ();
		public unowned string get_dbms_id ();
		public unowned Gda.DictType get_ret_dict_type ();
		public unowned string get_sqlname ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public DictAggregate (Gda.Dict dict);
		public void set_arg_dict_type (Gda.DictType dt);
		public void set_dbms_id (string id);
		public void set_ret_dict_type (Gda.DictType dt);
		public void set_sqlname (string sqlname);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictConstraint : Gda.Object, Gda.Referer, Gda.XmlStorage {
		public bool equal (Gda.DictConstraint cstr2);
		public static GLib.Quark error_quark ();
		public void fkey_get_actions (Gda.DictConstraintFkAction on_update, Gda.DictConstraintFkAction on_delete);
		public unowned GLib.SList fkey_get_fields ();
		public unowned Gda.DictTable fkey_get_ref_table ();
		public void fkey_set_actions (Gda.DictConstraintFkAction on_update, Gda.DictConstraintFkAction on_delete);
		public void fkey_set_fields (GLib.SList pairs);
		public Gda.DictConstraintType get_constraint_type ();
		public unowned Gda.DictTable get_table ();
		[CCode (has_construct_function = false)]
		public DictConstraint (Gda.DictTable table, Gda.DictConstraintType type);
		public unowned Gda.DictField not_null_get_field ();
		public void not_null_set_field (Gda.DictField field);
		public unowned GLib.SList pkey_get_fields ();
		public void pkey_set_fields (GLib.SList fields);
		public unowned GLib.SList unique_get_fields ();
		public void unique_set_fields (GLib.SList fields);
		public bool uses_field (Gda.DictField field);
		[CCode (has_construct_function = false)]
		public DictConstraint.with_db (Gda.DictDatabase db);
		[NoAccessorMethod]
		public bool user_constraint { get; set; }
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictConstraintFkeyPair {
		public weak Gda.DictField fkey;
		public weak Gda.DictField ref_pkey;
		public weak Gda.ObjectRef ref_pkey_repl;
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictDatabase : Gda.Object, Gda.XmlStorage {
		public void add_constraint (Gda.DictConstraint cstr);
		public static GLib.Quark error_quark ();
		public unowned GLib.SList get_all_constraints ();
		public unowned GLib.SList get_all_fk_constraints ();
		public unowned Gda.Dict get_dict ();
		public unowned Gda.DictField get_field_by_name (string fullname);
		public unowned Gda.DictField get_field_by_xml_id (string xml_id);
		public unowned Gda.DictTable get_table_by_name (string name);
		public unowned Gda.DictTable get_table_by_xml_id (string xml_id);
		public unowned GLib.SList get_table_constraints (Gda.DictTable table);
		public unowned GLib.SList get_tables ();
		public unowned GLib.SList get_tables_fk_constraints (Gda.DictTable table1, Gda.DictTable table2, bool table1_has_fk);
		[CCode (type = "GObject*", has_construct_function = false)]
		public DictDatabase (Gda.Dict dict);
		public void stop_update_dbms_data ();
		public bool update_dbms_data (GLib.Type limit_to_type, string limit_obj_name) throws GLib.Error;
		public virtual signal void constraint_added (Gda.DictConstraint cstr);
		public virtual signal void constraint_removed (Gda.DictConstraint cstr);
		public virtual signal void constraint_updated (Gda.DictConstraint cstr);
		public virtual signal void data_update_finished ();
		public virtual signal void data_update_started ();
		public virtual signal void field_added (Gda.DictField field);
		public virtual signal void field_removed (Gda.DictField field);
		public virtual signal void field_updated (Gda.DictField field);
		public virtual signal void table_added (Gda.DictTable table);
		public virtual signal void table_removed (Gda.DictTable table);
		public virtual signal void table_updated (Gda.DictTable table);
		public virtual signal void update_progress (string msg, uint now, uint total);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictField : Gda.Object, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public Gda.DictFieldAttribute get_attributes ();
		public unowned GLib.SList get_constraints ();
		public GLib.Value get_default_value ();
		public int get_length ();
		public int get_scale ();
		public bool is_fkey_alone ();
		public bool is_fkey_part ();
		public bool is_null_allowed ();
		public bool is_pkey_alone ();
		public bool is_pkey_part ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public DictField (Gda.Dict dict, Gda.DictType type);
		public void set_attributes (Gda.DictFieldAttribute attributes);
		public void set_default_value (GLib.Value value);
		public void set_length (int length);
		public void set_scale (int length);
		[NoAccessorMethod]
		public Gda.DictTable db_table { owned get; set; }
		[NoAccessorMethod]
		public string entry_plugin { owned get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictFunction : Gda.Object, Gda.XmlStorage {
		public bool accepts_arg_dict_types (GLib.SList arg_types);
		public static GLib.Quark error_quark ();
		public unowned GLib.SList get_arg_dict_types ();
		public unowned string get_dbms_id ();
		public unowned Gda.DictType get_ret_dict_type ();
		public unowned string get_sqlname ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public DictFunction (Gda.Dict dict);
		public void set_arg_dict_types (GLib.SList arg_types);
		public void set_dbms_id (string id);
		public void set_ret_dict_type (Gda.DictType dt);
		public void set_sqlname (string sqlname);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictRegisterStruct {
		public weak GLib.SList all_objects;
		public weak GLib.SList assumed_objects;
		public weak Gda.DictRegSyncFunc dbms_sync;
		public weak string dbms_sync_descr;
		public weak string dbms_sync_key;
		public weak Gda.DictRegFreeFunc free;
		public weak Gda.DictGetObjFunc get_by_name;
		public weak Gda.DictRegGetListFunc get_objects;
		public weak Gda.DictRegSaveFunc load_xml_tree;
		public weak Gda.DictRegLoadFunc save_xml_tree;
		public bool sort;
		public GLib.Type type;
		public weak string xml_group_tag;
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictTable : Gda.Object, Gda.Entity, Gda.XmlStorage {
		public static GLib.Quark error_quark ();
		public unowned GLib.SList get_constraints ();
		public unowned Gda.DictDatabase get_database ();
		public unowned GLib.SList get_parents ();
		public unowned Gda.DictConstraint get_pk_constraint ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public DictTable (Gda.Dict dict);
		public bool update_dbms_data () throws GLib.Error;
		[NoAccessorMethod]
		public Gda.DictDatabase database { owned get; set; }
		[NoAccessorMethod]
		public bool is_view { get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class DictType : Gda.Object, Gda.XmlStorage {
		public void add_synonym (string synonym);
		public void clear_synonyms ();
		public static GLib.Quark error_quark ();
		public GLib.Type get_g_type ();
		public unowned string get_sqlname ();
		public unowned GLib.SList get_synonyms ();
		[CCode (has_construct_function = false)]
		public DictType (Gda.Dict dict);
		public void set_g_type (GLib.Type g_type);
		public void set_sqlname (string sqlname);
	}
	[Compact]
	[CCode (copy_function = "gda_geometricpoint_copy", free_function = "gda_geometricpoint_free", cheader_filename = "libgda-3.0.h")]
	public class GeometricPoint {
		public double x;
		public double y;
		[CCode (cname = "gda_geometricpoint_copy")]
		public static void* copy (void* boxed);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Graph : Gda.Object, Gda.XmlStorage {
		public void add_item (Gda.GraphItem item);
		public void del_item (Gda.GraphItem item);
		public static GLib.Quark error_quark ();
		public Gda.GraphType get_graph_type ();
		public unowned Gda.GraphItem get_item_from_obj (Gda.Object ref_obj, bool create_if_needed);
		public unowned GLib.SList get_items ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public Graph (Gda.Dict dict, Gda.GraphType type);
		[NoAccessorMethod]
		public int graph_type { get; set; }
		[NoAccessorMethod]
		public Gda.Object ref_object { owned get; set; }
		public virtual signal void item_added (Gda.GraphItem item);
		public virtual signal void item_dropped (Gda.GraphItem item);
		public virtual signal void item_moved (Gda.GraphItem item);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class GraphItem : Gda.Object, Gda.XmlStorage {
		public static GLib.Quark error_quark ();
		public void get_position (double x, double y);
		public unowned Gda.Object get_ref_object ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public GraphItem (Gda.Dict dict, Gda.Object ref_obj);
		public void set_position (double x, double y);
		[NoAccessorMethod]
		public Gda.Object ref_object { owned get; set; }
		public virtual signal void moved ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class GraphQuery : Gda.Graph, Gda.XmlStorage {
		[CCode (type = "GObject*", has_construct_function = false)]
		public GraphQuery (Gda.Query query);
		public void sync_targets ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Graphviz : Gda.Object {
		public void add_to_graph (GLib.Object obj);
		[CCode (type = "GObject*", has_construct_function = false)]
		public Graphviz (Gda.Dict dict);
		public bool save_file (string filename) throws GLib.Error;
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerBin : Gda.Object, Gda.DataHandler {
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerBin ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerBinPriv {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerBoolean : Gda.Object, Gda.DataHandler {
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerBoolean ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerBooleanPriv {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerNumerical : Gda.Object, Gda.DataHandler {
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerNumerical ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerNumericalPriv {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerString : Gda.Object, Gda.DataHandler {
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerString ();
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerString.with_provider (Gda.ServerProvider prov, Gda.Connection cnc);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerStringPriv {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerTime : Gda.Object, Gda.DataHandler {
		public unowned string get_format (GLib.Type type);
		public unowned string get_no_locale_str_from_value (GLib.Value value);
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerTime ();
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerTime.no_locale ();
		public void set_sql_spec (GLib.DateDMY first, GLib.DateDMY sec, GLib.DateDMY third, char separator, bool twodigits_years);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerTimePriv {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerType : Gda.Object, Gda.DataHandler {
		[CCode (type = "GdaDataHandler*", has_construct_function = false)]
		public HandlerType ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class HandlerTypePriv {
	}
	[Compact]
	[CCode (copy_function = "gda_numeric_copy", cheader_filename = "libgda-3.0.h")]
	public class Numeric {
		public weak string number;
		public long precision;
		public long width;
		public static void* copy (void* boxed);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Object : GLib.Object {
		public void block_changed ();
		public static ulong connect_destroy (void* gdaobj, GLib.Callback callback, void* data);
		public void destroy ();
		public void destroy_check ();
		public unowned string get_description ();
		public unowned Gda.Dict get_dict ();
		public unowned string get_id ();
		public unowned string get_name ();
		public unowned string get_owner ();
		public void set_description (string descr);
		public void set_id (string strid);
		public void set_name (string name);
		public void set_owner (string owner);
		[NoWrapper]
		public virtual void signal_changed (bool block_changed_signal);
		public void signal_emit_changed ();
		public void unblock_changed ();
		[NoAccessorMethod]
		public bool changed_blocked { get; set; }
		public Gda.Dict dict { get; construct; }
		[NoAccessorMethod]
		public string string_id { owned get; set; }
		public virtual signal void changed ();
		public virtual signal void descr_changed ();
		public virtual signal void destroyed ();
		public virtual signal void id_changed ();
		public virtual signal void name_changed ();
		public virtual signal void owner_changed ();
		public virtual signal void to_be_destroyed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ObjectRef : Gda.Object {
		public bool activate ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public ObjectRef.copy (Gda.ObjectRef orig);
		public void deactivate ();
		public static GLib.Quark error_quark ();
		public unowned string get_ref_name (GLib.Type[] ref_type, Gda.ObjectRefType type);
		public unowned Gda.Object get_ref_object ();
		public unowned string get_ref_object_name ();
		public GLib.Type get_ref_type ();
		public bool is_active ();
		[CCode (type = "GObject*", has_construct_function = false)]
		public ObjectRef (Gda.Dict dict);
		[CCode (type = "GObject*", has_construct_function = false)]
		public ObjectRef.no_ref_count (Gda.Dict dict);
		public void replace_ref_object (GLib.HashTable replacements);
		public void set_ref_name (GLib.Type ref_type, Gda.ObjectRefType type, string name);
		public void set_ref_object (Gda.Object object);
		public void set_ref_object_type (Gda.Object object, GLib.Type type);
		[NoAccessorMethod]
		public Gda.Object helper_ref { owned get; set; }
		[NoAccessorMethod]
		public string obj_name { owned get; set; }
		public virtual signal void ref_found ();
		public virtual signal void ref_lost ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Parameter : Gda.Object, Gda.Referer {
		public void bind_to_param (Gda.Parameter bind_to);
		[CCode (has_construct_function = false)]
		public Parameter.boolean (global::string name, bool value);
		[CCode (has_construct_function = false)]
		public Parameter.copy (Gda.Parameter orig);
		public void declare_invalid ();
		public void declare_param_user (Gda.Object user);
		public static GLib.Quark error_quark ();
		public unowned global::string get_alphanum_name ();
		public unowned Gda.Parameter get_bind_param ();
		public GLib.Value get_default_value ();
		public bool get_exists_default_value ();
		public GLib.Type get_g_type ();
		public bool get_not_null ();
		public unowned GLib.SList get_param_users ();
		public GLib.Value get_value ();
		public unowned global::string get_value_str ();
		public bool has_restrict_values (out unowned Gda.DataModel model, int col);
		public bool is_valid ();
		[CCode (has_construct_function = false)]
		public Parameter (GLib.Type type);
		public void replace_param_users (GLib.HashTable replacements);
		[NoWrapper]
		public virtual void reserved_0 ();
		[NoWrapper]
		public virtual void reserved_1 ();
		[NoWrapper]
		public virtual void reserved_2 ();
		[NoWrapper]
		public virtual void reserved_3 ();
		public bool restrict_values (Gda.DataModel model, int col) throws GLib.Error;
		public void set_default_value (GLib.Value value);
		public void set_exists_default_value (bool default_value_exists);
		public void set_not_null (bool not_null);
		public void set_value (GLib.Value value);
		public bool set_value_str (global::string value);
		[CCode (has_construct_function = false)]
		public Parameter.string (global::string name, global::string str);
		[NoAccessorMethod]
		public global::string entry_plugin { owned get; set; }
		[NoAccessorMethod]
		public Gda.Parameter full_bind { owned get; set; }
		public ulong g_type { get; construct; }
		public bool not_null { get; set; }
		[NoAccessorMethod]
		public int restrict_column { get; set; }
		[NoAccessorMethod]
		public Gda.DataModel restrict_model { owned get; set; }
		[NoAccessorMethod]
		public Gda.Parameter simple_bind { owned get; set; }
		[NoAccessorMethod]
		public bool use_default_value { get; set; }
		public virtual signal void restrict_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ParameterList : Gda.Object {
		public weak GLib.SList groups_list;
		public weak GLib.SList nodes_list;
		public weak GLib.SList parameters;
		public weak GLib.SList sources_list;
		public void add_param (Gda.Parameter param);
		public unowned Gda.Parameter add_param_from_string (string name, GLib.Type type, string str);
		public unowned Gda.Parameter add_param_from_value (string name, GLib.Value value);
		public static GLib.Quark error_quark ();
		public unowned Gda.ParameterListGroup find_group_for_param (Gda.Parameter param);
		public unowned Gda.ParameterListNode find_node_for_param (Gda.Parameter param);
		public unowned Gda.Parameter find_param (string param_name);
		public unowned Gda.Parameter find_param_for_user (Gda.Object user);
		public unowned Gda.ParameterListSource find_source (Gda.DataModel model);
		public unowned Gda.ParameterListSource find_source_for_param (Gda.Parameter param);
		[CCode (has_construct_function = false)]
		public ParameterList.from_spec_node (Gda.Dict dict, Xml.Node xml_spec) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public ParameterList.from_spec_string (Gda.Dict dict, string xml_spec) throws GLib.Error;
		public uint get_length ();
		public GLib.Value get_param_default_value (Gda.Parameter param);
		public unowned string get_spec ();
		[CCode (has_construct_function = false)]
		public ParameterList.inline (Gda.Dict dict);
		public bool is_coherent () throws GLib.Error;
		public bool is_valid ();
		public void merge (Gda.ParameterList paramlist_to_merge);
		[CCode (has_construct_function = false)]
		public ParameterList (GLib.SList params);
		public void set_param_default_alias (Gda.Parameter param, Gda.Parameter alias);
		public void set_param_default_value (Gda.Parameter param, GLib.Value value);
		public void* params { construct; }
		public virtual signal void param_attr_changed (Gda.Parameter param);
		public virtual signal void param_changed (Gda.Parameter param);
		public virtual signal void param_plugin_changed (Gda.Parameter param);
		public virtual signal void public_data_changed ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ParameterListGroup {
		public weak GLib.SList nodes;
		public weak Gda.ParameterListSource nodes_source;
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ParameterListNode {
		public uint hint;
		public weak Gda.Parameter param;
		public int source_column;
		public weak Gda.DataModel source_model;
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ParameterListSource {
		public weak Gda.DataModel data_model;
		public weak GLib.SList nodes;
		public int ref_cols_index;
		public int ref_n_cols;
		public int shown_cols_index;
		public int shown_n_cols;
	}
	[Compact]
	[CCode (free_function = "parse_data_destroy", cheader_filename = "libgda-3.0.h")]
	public class ParseData {
		public weak GLib.HashTable new_targets;
		public weak GLib.SList parsed_targets;
		public weak GLib.SList prev_fields;
		public weak GLib.SList prev_targets;
		public weak GLib.HashTable sql_table_targets;
		[CCode (cname = "parse_data_compute_targets_hash")]
		public static void compute_targets_hash (Gda.Query query, Gda.ParseData pdata);
		[CCode (cname = "parse_data_new", type = "ParseData*", has_construct_function = false)]
		public ParseData (Gda.Query query);
	}
	[Compact]
	[CCode (copy_function = "gda_provider_info_copy", cheader_filename = "libgda-3.0.h")]
	public class ProviderInfo {
		public weak string description;
		public weak string dsn_spec;
		public weak Gda.ParameterList gda_params;
		public weak string id;
		public weak string location;
		public unowned Gda.ProviderInfo copy ();
	}
	[Compact]
	[CCode (copy_function = "gda_quark_list_copy", cheader_filename = "libgda-3.0.h")]
	public class QuarkList {
		public void add_from_string (string str, bool cleanup);
		public void clear ();
		public unowned Gda.QuarkList copy ();
		public unowned string find (string name);
		public void @foreach (GLib.HFunc func);
		[CCode (has_construct_function = false)]
		public QuarkList.from_string (string str);
		[CCode (has_construct_function = false)]
		public QuarkList ();
		public void remove (string name);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Query : Gda.QueryObject, Gda.Entity, Gda.Referer, Gda.XmlStorage, Gda.Renderer {
		public unowned Gda.QueryField add_field_from_sql (string field) throws GLib.Error;
		public bool add_join (Gda.QueryJoin join);
		public void add_param_source (Gda.DataModel param_source);
		public void add_sub_query (Gda.Query sub_query);
		public bool add_target (Gda.QueryTarget target) throws GLib.Error;
		public void append_condition (Gda.QueryCondition cond, bool append_as_and);
		[CCode (has_construct_function = false)]
		public Query.copy (Gda.Query orig, GLib.HashTable replacements);
		public void declare_condition (Gda.QueryCondition cond);
		public void del_join (Gda.QueryJoin join);
		public void del_param_source (Gda.DataModel param_source);
		public void del_sub_query (Gda.Query sub_query);
		public void del_target (Gda.QueryTarget target);
		public static GLib.Quark error_quark ();
		public unowned Gda.Object execute (Gda.ParameterList params, bool iter_model_only_requested) throws GLib.Error;
		public unowned GLib.SList expand_all_field (Gda.QueryTarget target);
		[CCode (has_construct_function = false)]
		public Query.from_sql (Gda.Dict dict, string sql) throws GLib.Error;
		public unowned GLib.SList get_all_fields ();
		public unowned Gda.QueryCondition get_condition ();
		public unowned Gda.QueryField get_field_by_param_name (string param_name);
		public unowned Gda.QueryField get_field_by_ref_field (Gda.QueryTarget target, Gda.EntityField ref_field, Gda.QueryFieldState field_state);
		public unowned Gda.QueryField get_field_by_sql_naming (string sql_name);
		public unowned Gda.QueryField get_field_by_sql_naming_fields (string sql_name, GLib.SList fields_list);
		public unowned GLib.SList get_fields_by_target (Gda.QueryTarget target, bool visible_fields_only);
		public unowned Gda.QueryField get_first_field_for_target (Gda.QueryTarget target);
		public unowned Gda.QueryJoin get_join_by_targets (Gda.QueryTarget target1, Gda.QueryTarget target2);
		public unowned GLib.SList get_joins ();
		public unowned GLib.SList get_main_conditions ();
		public int get_order_by_field (Gda.QueryField field, bool ascendant);
		public unowned GLib.SList get_param_sources ();
		public unowned Gda.ParameterList get_parameter_list ();
		public unowned GLib.SList get_parameters ();
		public unowned Gda.Query get_parent_query ();
		public Gda.QueryType get_query_type ();
		public unowned string get_query_type_string ();
		public unowned string get_sql_text ();
		public unowned GLib.SList get_sub_queries ();
		public unowned Gda.QueryTarget get_target_by_alias (string alias_or_name);
		public unowned Gda.QueryTarget get_target_by_xml_id (string xml_id);
		public unowned GLib.SList get_target_pkfields (Gda.QueryTarget target);
		public unowned GLib.SList get_targets ();
		public bool is_delete_query ();
		public bool is_insert_query ();
		public bool is_modify_query ();
		public bool is_select_query ();
		public bool is_update_query ();
		public bool is_well_formed (Gda.ParameterList context) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public Query (Gda.Dict dict);
		public void order_fields_using_join_conds ();
		public void set_condition (Gda.QueryCondition cond);
		public void set_order_by_field (Gda.QueryField field, int order, bool ascendant);
		public void set_query_type (Gda.QueryType type);
		public void set_sql_text (string sql) throws GLib.Error;
		public void undeclare_condition (Gda.QueryCondition cond);
		[NoAccessorMethod]
		public bool auto_clean { get; set; }
		[NoAccessorMethod]
		public uint cond_serial { get; }
		[NoAccessorMethod]
		public uint field_serial { get; }
		[NoAccessorMethod]
		public void* really_all_fields { get; }
		[NoAccessorMethod]
		public uint target_serial { get; }
		public virtual signal void condition_changed ();
		public virtual signal void join_added (Gda.QueryJoin join);
		public virtual signal void join_removed (Gda.QueryJoin join);
		public virtual signal void join_updated (Gda.QueryJoin join);
		public virtual signal void sub_query_added (Gda.Query sub_query);
		public virtual signal void sub_query_removed (Gda.Query sub_query);
		public virtual signal void sub_query_updated (Gda.Query sub_query);
		public virtual signal void target_added (Gda.QueryTarget target);
		public virtual signal void target_removed (Gda.QueryTarget target);
		public virtual signal void target_updated (Gda.QueryTarget target);
		public virtual signal void type_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryCondition : Gda.QueryObject, Gda.Referer, Gda.XmlStorage, Gda.Renderer {
		[CCode (has_construct_function = false)]
		public QueryCondition.copy (Gda.QueryCondition orig, GLib.HashTable replacements);
		public static GLib.Quark error_quark ();
		[CCode (has_construct_function = false)]
		public QueryCondition.from_sql (Gda.Query query, string sql_cond, GLib.SList targets) throws GLib.Error;
		public unowned Gda.QueryCondition get_child_by_xml_id (string xml_id);
		public unowned GLib.SList get_children ();
		public Gda.QueryConditionType get_cond_type ();
		public unowned GLib.SList get_main_conditions ();
		public unowned Gda.QueryCondition get_parent ();
		public unowned GLib.SList get_ref_objects_all ();
		public bool is_ancestor (Gda.QueryCondition ancestor);
		public bool is_leaf ();
		public unowned Gda.QueryField leaf_get_operator (Gda.QueryConditionOperator op);
		public void leaf_set_operator (Gda.QueryConditionOperator op, Gda.QueryField field);
		[CCode (has_construct_function = false)]
		public QueryCondition (Gda.Query query, Gda.QueryConditionType type);
		public bool node_add_child (Gda.QueryCondition child) throws GLib.Error;
		public void node_del_child (Gda.QueryCondition child);
		public bool represents_join (out unowned Gda.QueryTarget target1, out unowned Gda.QueryTarget target2, bool is_equi_join);
		public bool represents_join_strict (out unowned Gda.QueryTarget target1, out unowned Gda.QueryTarget target2);
		public void set_cond_type (Gda.QueryConditionType type);
		public int cond_type { get; set; }
		[NoAccessorMethod]
		public Gda.QueryJoin join { owned get; set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryField : Gda.QueryObject {
		[NoWrapper]
		public virtual unowned GLib.Object copy ();
		public static GLib.Quark error_quark ();
		[CCode (cname = "gda_query_field_new_copy", has_construct_function = false)]
		public QueryField.from_copy (Gda.QueryField orig);
		[CCode (has_construct_function = false)]
		public QueryField.from_sql (Gda.Query query, string sqlfield) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public QueryField.from_xml (Gda.Query query, Xml.Node node) throws GLib.Error;
		public unowned string get_alias ();
		public unowned Gda.DictType get_dict_type ();
		public unowned GLib.SList get_parameters ();
		[NoWrapper]
		public virtual unowned GLib.SList get_params ();
		public virtual bool is_equal (Gda.QueryField qfield2);
		public bool is_internal ();
		public virtual bool is_list ();
		public bool is_visible ();
		public void set_alias (string alias);
		public void set_internal (bool internal);
		public void set_visible (bool visible);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryFieldAgg : Gda.QueryField, Gda.Referer, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public unowned Gda.QueryField get_arg ();
		public unowned Gda.DictAggregate get_ref_agg ();
		[CCode (type = "GdaQueryField*", has_construct_function = false)]
		public QueryFieldAgg (Gda.Query query, string agg_name);
		public bool set_arg (Gda.QueryField arg);
		[NoAccessorMethod]
		public Gda.DictAggregate aggregate { owned get; set; }
		[NoAccessorMethod]
		public string aggregate_id { set; }
		[NoAccessorMethod]
		public string aggregate_name { set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryFieldAll : Gda.QueryField, Gda.Referer, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public unowned Gda.QueryTarget get_target ();
		[CCode (type = "GdaQueryField*", has_construct_function = false)]
		public QueryFieldAll (Gda.Query query, string target);
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
		[NoAccessorMethod]
		public Gda.QueryTarget target { owned get; set; }
		[NoAccessorMethod]
		public string target_id { set; }
		[NoAccessorMethod]
		public string target_name { set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryFieldField : Gda.QueryField, Gda.Referer, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public unowned Gda.EntityField get_ref_field ();
		public unowned string get_ref_field_name ();
		public unowned Gda.QueryTarget get_target ();
		[CCode (type = "GdaQueryField*", has_construct_function = false)]
		public QueryFieldField (Gda.Query query, string field);
		[NoAccessorMethod]
		public string entry_plugin { owned get; set; }
		[NoAccessorMethod]
		public Gda.EntityField field { owned get; set; }
		[NoAccessorMethod]
		public string field_id { set; }
		[NoAccessorMethod]
		public string field_name { owned get; set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
		[NoAccessorMethod]
		public Gda.QueryTarget target { owned get; set; }
		[NoAccessorMethod]
		public string target_id { set; }
		[NoAccessorMethod]
		public string target_name { set; }
		[NoAccessorMethod]
		public Gda.QueryField value_provider { owned get; set; }
		[NoAccessorMethod]
		public string value_provider_xml_id { owned get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryFieldFunc : Gda.QueryField, Gda.Referer, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public unowned GLib.SList get_args ();
		public unowned Gda.DictFunction get_ref_func ();
		public unowned string get_ref_func_name ();
		[CCode (type = "GdaQueryField*", has_construct_function = false)]
		public QueryFieldFunc (Gda.Query query, string func_name);
		public bool set_args (GLib.SList args);
		[NoAccessorMethod]
		public Gda.DictFunction function { owned get; set; }
		[NoAccessorMethod]
		public string function_id { set; }
		[NoAccessorMethod]
		public string function_name { set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryFieldValue : Gda.QueryField, Gda.Referer, Gda.XmlStorage, Gda.EntityField, Gda.Renderer {
		public static GLib.Quark error_quark ();
		public GLib.Value get_default_value ();
		public bool get_is_parameter ();
		public bool get_not_null ();
		public int get_parameter_index ();
		public GLib.Value get_value ();
		public bool is_value_null (Gda.ParameterList context);
		[CCode (type = "GdaQueryField*", has_construct_function = false)]
		public QueryFieldValue (Gda.Query query, GLib.Type type);
		public bool restrict (Gda.DataModel model, int col) throws GLib.Error;
		public void set_default_value (GLib.Value default_val);
		public void set_is_parameter (bool is_param);
		public void set_not_null (bool not_null);
		public void set_value (GLib.Value val);
		[NoAccessorMethod]
		public string entry_plugin { owned get; set; }
		[NoAccessorMethod]
		public ulong g_type { get; set; }
		public bool is_parameter { get; set; }
		[NoAccessorMethod]
		public Gda.Query query { owned get; construct; }
		[NoAccessorMethod]
		public int restrict_column { get; set; }
		[NoAccessorMethod]
		public Gda.DataModel restrict_model { owned get; set; }
		[NoAccessorMethod]
		public string string_type { owned get; set; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryJoin : Gda.QueryObject, Gda.Referer, Gda.XmlStorage {
		[CCode (has_construct_function = false)]
		public QueryJoin.copy (Gda.QueryJoin orig, GLib.HashTable replacements);
		public static GLib.Quark error_quark ();
		public unowned Gda.QueryCondition get_condition ();
		public Gda.QueryJoinType get_join_type ();
		public unowned Gda.Query get_query ();
		public unowned Gda.QueryTarget get_target_1 ();
		public unowned Gda.QueryTarget get_target_2 ();
		public unowned string render_type ();
		public bool set_condition (Gda.QueryCondition cond);
		public bool set_condition_from_fkcons ();
		public bool set_condition_from_sql (string cond) throws GLib.Error;
		public void set_join_type (Gda.QueryJoinType type);
		public void swap_targets ();
		[CCode (has_construct_function = false)]
		public QueryJoin.with_targets (Gda.Query query, Gda.QueryTarget target_1, Gda.QueryTarget target_2);
		[CCode (has_construct_function = false)]
		public QueryJoin.with_xml_ids (Gda.Query query, string target_1_xml_id, string target_2_xml_id);
		public Gda.Query query { get; construct; }
		[NoAccessorMethod]
		public Gda.QueryTarget target1 { owned get; set; }
		[NoAccessorMethod]
		public string target1_id { set; }
		[NoAccessorMethod]
		public Gda.QueryTarget target2 { owned get; set; }
		[NoAccessorMethod]
		public string target2_id { set; }
		public virtual signal void condition_changed ();
		public virtual signal void type_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryObject : Gda.Object {
		public uint get_int_id ();
		public virtual void set_int_id (uint id);
		public virtual signal void numid_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class QueryTarget : Gda.QueryObject, Gda.Referer, Gda.XmlStorage, Gda.Renderer {
		[CCode (has_construct_function = false)]
		public QueryTarget.copy (Gda.QueryTarget orig);
		public static GLib.Quark error_quark ();
		public unowned string get_alias ();
		public unowned string get_complete_name ();
		public unowned Gda.Query get_query ();
		public unowned Gda.Entity get_represented_entity ();
		public unowned string get_represented_table_name ();
		[CCode (has_construct_function = false)]
		public QueryTarget (Gda.Query query, string table);
		public void set_alias (string alias);
		[NoAccessorMethod]
		public Gda.Entity entity { owned get; set; }
		[NoAccessorMethod]
		public string entity_id { set; }
		[NoAccessorMethod]
		public string entity_name { set; }
		public Gda.Query query { get; construct; }
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Row : GLib.Object {
		public unowned Gda.Row copy ();
		[CCode (has_construct_function = false)]
		public Row.from_list (Gda.DataModel model, GLib.List values);
		public unowned string get_id ();
		public bool get_is_default (int num);
		public int get_length ();
		public unowned Gda.DataModel get_model ();
		public int get_number ();
		public GLib.Value get_value (int num);
		[CCode (has_construct_function = false)]
		public Row (Gda.DataModel model, int count);
		public void set_id (string id);
		public void set_is_default (int num, bool is_default);
		public void set_model (Gda.DataModel model);
		public void set_number (int number);
		public bool set_value (int num, GLib.Value value);
		public Gda.DataModel model { get; set; }
		[NoAccessorMethod]
		public int nb_values { set; }
		[NoAccessorMethod]
		public void* values { set; }
		public virtual signal void value_changed (int num, GLib.Value old_value, GLib.Value new_value);
		public virtual signal bool value_to_change (int num, GLib.Value current, GLib.Value proposed);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ServerOperation : GLib.Object {
		public uint add_item_to_sequence (string path);
		public bool del_item_from_sequence (string item_path);
		public unowned Gda.ServerOperationNode get_node_info (string path_format);
		public unowned string get_node_parent (string path);
		public unowned string get_node_path_portion (string path);
		public Gda.ServerOperationNodeType get_node_type (string path, Gda.ServerOperationNodeStatus status);
		public Gda.ServerOperationType get_op_type ();
		public unowned string get_root_nodes ();
		public unowned string get_sequence_item_names (string path);
		public uint get_sequence_max_size (string path);
		public uint get_sequence_min_size (string path);
		public unowned string get_sequence_name (string path);
		public uint get_sequence_size (string path);
		public GLib.Value get_value_at (string path_format);
		public bool is_valid (string xml_file) throws GLib.Error;
		public bool load_data_from_xml (Xml.Node node) throws GLib.Error;
		[CCode (has_construct_function = false)]
		public ServerOperation (Gda.ServerOperationType op_type, string xml_file);
		public static unowned string op_type_to_string (Gda.ServerOperationType type);
		public unowned Xml.Node save_data_to_xml () throws GLib.Error;
		[NoWrapper]
		public virtual void seq_item_added (string seq_path, int item_index);
		[NoWrapper]
		public virtual void seq_item_remove (string seq_path, int item_index);
		public bool set_value_at (string value, string path_format) throws GLib.Error;
		public Gda.Connection connection { construct; }
		public Gda.Dict dict { construct; }
		public int op_type { get; construct; }
		public Gda.ServerProvider provider_obj { construct; }
		public string spec_file { construct; }
		public virtual signal void sequence_item_added (string p0, int p1);
		public virtual signal void sequence_item_remove (string p0, int p1);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ServerOperationNode {
		public weak Gda.Column column;
		public weak Gda.DataModel model;
		public weak Gda.Parameter param;
		public weak Gda.ParameterList plist;
		public void* priv;
		public Gda.ServerOperationNodeStatus status;
		public Gda.ServerOperationNodeType type;
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ServerProvider : GLib.Object {
		public virtual bool add_savepoint (Gda.Connection cnc, string name) throws GLib.Error;
		public virtual bool begin_transaction (Gda.Connection cnc, string name, Gda.TransactionIsolation level) throws GLib.Error;
		public static bool blob_list_for_delete (Gda.Connection cnc, Gda.Query query, out unowned Gda.Query out_select) throws GLib.Error;
		public static bool blob_list_for_update (Gda.Connection cnc, Gda.Query query, out unowned Gda.Query out_select) throws GLib.Error;
		public virtual bool change_database (Gda.Connection cnc, string name);
		public virtual bool close_connection (Gda.Connection cnc);
		public virtual bool commit_transaction (Gda.Connection cnc, string name) throws GLib.Error;
		public virtual unowned Gda.ServerOperation create_operation (Gda.Connection cnc, Gda.ServerOperationType type, Gda.ParameterList options) throws GLib.Error;
		public virtual bool delete_savepoint (Gda.Connection cnc, string name) throws GLib.Error;
		public virtual unowned string escape_string (Gda.Connection cnc, string str);
		public virtual unowned GLib.List execute_command (Gda.Connection cnc, Gda.Command cmd, Gda.ParameterList params);
		public virtual unowned Gda.Object execute_query (Gda.Connection cnc, Gda.Query query, Gda.ParameterList params);
		public unowned string find_file (string inst_dir, string filename);
		[NoWrapper]
		public virtual unowned Gda.DataHandler get_data_handler (Gda.Connection cnc, GLib.Type g_type, string dbms_type);
		public unowned Gda.DataHandler get_data_handler_dbms (Gda.Connection cnc, string for_type);
		public unowned Gda.DataHandler get_data_handler_gtype (Gda.Connection cnc, GLib.Type for_type);
		public virtual unowned string get_database (Gda.Connection cnc);
		[NoWrapper]
		public virtual unowned string get_def_dbms_type (Gda.Connection cnc, GLib.Type g_type);
		public unowned string get_default_dbms_type (Gda.Connection cnc, GLib.Type type);
		public virtual unowned Gda.ServerProviderInfo get_info (Gda.Connection cnc);
		public virtual unowned string get_last_insert_id (Gda.Connection cnc, Gda.DataModel recset);
		public virtual unowned Gda.DataModel get_schema (Gda.Connection cnc, Gda.ConnectionSchema schema, Gda.ParameterList params) throws GLib.Error;
		public static int get_schema_nb_columns (Gda.ConnectionSchema schema);
		public virtual unowned string get_server_version (Gda.Connection cnc);
		public virtual unowned string get_version ();
		public void handler_declare (Gda.DataHandler dh, Gda.Connection cnc, GLib.Type g_type, string dbms_type);
		public unowned Gda.DataHandler handler_find (Gda.Connection cnc, GLib.Type g_type, string dbms_type);
		public static bool init_schema_model (Gda.DataModel model, Gda.ConnectionSchema schema);
		[NoWrapper]
		public virtual void last_connection_gone ();
		public static unowned string load_file_contents (string inst_dir, string data_dir, string filename);
		public virtual bool open_connection (Gda.Connection cnc, Gda.QuarkList params, string username, string password);
		public virtual bool perform_operation (Gda.Connection cnc, Gda.ServerOperation op) throws GLib.Error;
		public virtual unowned string render_operation (Gda.Connection cnc, Gda.ServerOperation op) throws GLib.Error;
		public virtual bool rollback_savepoint (Gda.Connection cnc, string name) throws GLib.Error;
		public virtual bool rollback_transaction (Gda.Connection cnc, string name) throws GLib.Error;
		public static bool select_query_has_blobs (Gda.Connection cnc, Gda.Query query) throws GLib.Error;
		public static bool split_update_query (Gda.Connection cnc, Gda.Query query, out unowned Gda.Query out_query) throws GLib.Error;
		public virtual GLib.Value string_to_value (Gda.Connection cnc, string str, GLib.Type prefered_type, string dbms_type);
		public virtual bool supports_feature (Gda.Connection cnc, Gda.ConnectionFeature feature);
		public virtual bool supports_operation (Gda.Connection cnc, Gda.ServerOperationType type, Gda.ParameterList options);
		public static bool test_schema_model (Gda.DataModel model, Gda.ConnectionSchema schema) throws GLib.Error;
		public virtual unowned string unescape_string (Gda.Connection cnc, string str);
		public unowned string value_to_sql_string (Gda.Connection cnc, GLib.Value from);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ServerProviderHandlerInfo {
		public weak Gda.Connection cnc;
		public weak string dbms_type;
		public GLib.Type g_type;
		public bool equal_func (Gda.ServerProviderHandlerInfo b);
		public uint hash_func ();
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ServerProviderInfo {
		public bool alias_needs_as_keyword;
		public bool implicit_data_types_casts;
		public bool is_case_insensitive;
		public weak string provider_name;
		public bool quote_non_lc_identifiers;
		[CCode (array_length = false)]
		public weak bool[] reserved;
		public bool supports_alias;
		public bool supports_prefixed_fields;
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class Threader : GLib.Object {
		public void cancel (uint job_id);
		[CCode (type = "GObject*", has_construct_function = false)]
		public Threader ();
		public uint start_thread (GLib.ThreadFunc func, void* func_arg, Gda.ThreaderFunc ok_callback, Gda.ThreaderFunc cancel_callback) throws GLib.Error;
		public virtual signal void cancelled (uint job_id, void* arg_data);
		public virtual signal void finished (uint job_id, void* arg_data);
	}
	[Compact]
	[CCode (copy_function = "gda_time_copy", cheader_filename = "libgda-3.0.h")]
	public class Time {
		public ulong fraction;
		public ushort hour;
		public ushort minute;
		public ushort second;
		public long timezone;
		public static void* copy (void* boxed);
	}
	[Compact]
	[CCode (copy_function = "gda_timestamp_copy", cheader_filename = "libgda-3.0.h")]
	public class Timestamp {
		public ushort day;
		public ulong fraction;
		public ushort hour;
		public ushort minute;
		public ushort month;
		public ushort second;
		public long timezone;
		public short year;
		public static void* copy (void* boxed);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class TransactionStatus : GLib.Object {
		public weak GLib.List events;
		public Gda.TransactionIsolation isolation_level;
		public weak string name;
		public Gda.TransactionStatusState state;
		public unowned Gda.TransactionStatusEvent add_event_sql (string sql, Gda.ConnectionEvent conn_event);
		public unowned Gda.TransactionStatusEvent add_event_sub (Gda.TransactionStatus sub_trans);
		public unowned Gda.TransactionStatusEvent add_event_svp (string svp_name);
		public unowned Gda.TransactionStatus find (string str, out unowned Gda.TransactionStatusEvent destev);
		public unowned Gda.TransactionStatus find_current (out unowned Gda.TransactionStatusEvent destev, bool unnamed_only);
		public void free_events (Gda.TransactionStatusEvent event, bool free_after);
		[CCode (has_construct_function = false)]
		public TransactionStatus (string name);
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class TransactionStatusEvent {
		public weak Gda.ConnectionEvent conn_event;
		public void* pl;
		public void* reserved1;
		public void* reserved2;
		public weak Gda.TransactionStatus trans;
		public Gda.TransactionStatusEventType type;
	}
	[Compact]
	[CCode (cheader_filename = "libgda-3.0.h")]
	public class ValueList {
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface DataHandler : GLib.Object {
		public abstract bool accepts_g_type (GLib.Type type);
		public abstract unowned string get_descr ();
		public abstract GLib.Type get_g_type_index (uint index);
		public abstract uint get_nb_g_types ();
		public abstract GLib.Value get_sane_init_value (GLib.Type type);
		public abstract unowned string get_sql_from_value (GLib.Value value);
		public abstract unowned string get_str_from_value (GLib.Value value);
		public abstract GLib.Value get_value_from_sql (string sql, GLib.Type type);
		public abstract GLib.Value get_value_from_str (string str, GLib.Type type);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface DataModel : Gda.Object {
		public bool add_data_from_xml_node (Xml.Node node) throws GLib.Error;
		public int append_row () throws GLib.Error;
		public int append_values (GLib.List values) throws GLib.Error;
		public unowned Gda.DataModelIter create_iter ();
		public unowned Gda.Column describe_column (int col);
		public void dump (GLib.FileStream to_stream);
		public unowned string dump_as_string ();
		public bool export_to_file (Gda.DataModelIOFormat format, string file, int cols, int nb_cols, int rows, int nb_rows, Gda.ParameterList options) throws GLib.Error;
		public unowned string export_to_string (Gda.DataModelIOFormat format, int cols, int nb_cols, int rows, int nb_rows, Gda.ParameterList options);
		public void freeze ();
		public Gda.DataModelAccessFlags get_access_flags ();
		public Gda.ValueAttribute get_attributes_at (int col, int row);
		public int get_column_index_by_name (string name);
		public unowned string get_column_title (int col);
		public int get_n_columns ();
		public int get_n_rows ();
		public int get_row_from_values (GLib.SList values, int cols_index);
		public GLib.Value get_value_at (int col, int row);
		public GLib.Value get_value_at_col_name (string column_name, int row);
		[NoWrapper]
		public abstract int i_append_row () throws GLib.Error;
		[NoWrapper]
		public abstract int i_append_values (GLib.List values) throws GLib.Error;
		[NoWrapper]
		public abstract unowned Gda.DataModelIter i_create_iter ();
		[NoWrapper]
		public abstract unowned Gda.Column i_describe_column (int col);
		[NoWrapper]
		public abstract int i_find_row (GLib.SList values, int cols_index);
		[NoWrapper]
		public abstract Gda.DataModelAccessFlags i_get_access_flags ();
		[NoWrapper]
		public abstract Gda.ValueAttribute i_get_attributes_at (int col, int row);
		[NoWrapper]
		public abstract int i_get_n_columns ();
		[NoWrapper]
		public abstract int i_get_n_rows ();
		[NoWrapper]
		public abstract bool i_get_notify ();
		[NoWrapper]
		public abstract GLib.Value i_get_value_at (int col, int row);
		[NoWrapper]
		public abstract bool i_iter_at_row (Gda.DataModelIter iter, int row);
		[NoWrapper]
		public abstract bool i_iter_next (Gda.DataModelIter iter);
		[NoWrapper]
		public abstract bool i_iter_prev (Gda.DataModelIter iter);
		[NoWrapper]
		public abstract bool i_remove_row (int row) throws GLib.Error;
		[NoWrapper]
		public abstract void i_send_hint (Gda.DataModelHint hint, GLib.Value hint_value);
		[NoWrapper]
		public abstract void i_set_notify (bool do_notify_changes);
		[NoWrapper]
		public abstract bool i_set_value_at (int col, int row, GLib.Value value) throws GLib.Error;
		[NoWrapper]
		public abstract bool i_set_values (int row, GLib.List values) throws GLib.Error;
		public bool is_updatable ();
		public bool move_iter_at_row (Gda.DataModelIter iter, int row);
		public bool move_iter_at_row_default (Gda.DataModelIter iter, int row);
		public bool move_iter_next (Gda.DataModelIter iter);
		public bool move_iter_next_default (Gda.DataModelIter iter);
		public bool move_iter_prev (Gda.DataModelIter iter);
		public bool move_iter_prev_default (Gda.DataModelIter iter);
		public bool remove_row (int row) throws GLib.Error;
		public void send_hint (Gda.DataModelHint hint, GLib.Value hint_value);
		public void set_column_title (int col, string title);
		public bool set_value_at (int col, int row, GLib.Value value) throws GLib.Error;
		public bool set_values (int row, GLib.List values) throws GLib.Error;
		public void signal_emit_changed ();
		public void thaw ();
		public unowned Xml.Node to_xml_node (int cols, int nb_cols, int rows, int nb_rows, string name);
		[HasEmitter]
		public virtual signal void reset ();
		public virtual signal void row_inserted (int row);
		public virtual signal void row_removed (int row);
		public virtual signal void row_updated (int row);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface Entity : Gda.Object {
		public abstract void add_field (Gda.EntityField field);
		public abstract void add_field_before (Gda.EntityField field, Gda.EntityField field_before);
		public abstract unowned Gda.EntityField get_field_by_index (int index);
		public abstract unowned Gda.EntityField get_field_by_name (string name);
		public abstract unowned Gda.EntityField get_field_by_xml_id (string xml_id);
		public abstract int get_field_index (Gda.EntityField field);
		public abstract unowned GLib.SList get_fields ();
		public int get_n_fields ();
		public abstract bool has_field (Gda.EntityField field);
		public abstract bool is_writable ();
		public abstract void remove_field (Gda.EntityField field);
		public abstract void swap_fields (Gda.EntityField field1, Gda.EntityField field2);
		public virtual signal void field_added (Gda.EntityField field);
		public virtual signal void field_removed (Gda.EntityField field);
		public virtual signal void field_updated (Gda.EntityField field);
		public virtual signal void fields_order_changed ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface EntityField : Gda.Object {
		[NoWrapper]
		public abstract unowned string get_alias ();
		public unowned string get_description ();
		public abstract unowned Gda.DictType get_dict_type ();
		public abstract unowned Gda.Entity get_entity ();
		public abstract GLib.Type get_g_type ();
		public unowned string get_name ();
		public abstract void set_dict_type (Gda.DictType type);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface Referer : GLib.Object {
		public abstract bool activate ();
		public abstract void deactivate ();
		public abstract unowned GLib.SList get_ref_objects ();
		public abstract bool is_active ();
		public abstract void replace_refs (GLib.HashTable replacements);
		public virtual signal void activated ();
		public virtual signal void deactivated ();
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface Renderer : GLib.Object {
		public abstract bool is_valid (Gda.ParameterList context) throws GLib.Error;
		public abstract unowned string render_as_sql (Gda.ParameterList context, GLib.SList out_params_used, Gda.RendererOptions options) throws GLib.Error;
		public abstract unowned string render_as_str (Gda.ParameterList context);
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public interface XmlStorage : Gda.Object {
		public abstract unowned string get_xml_id ();
		public abstract bool load_from_xml (Xml.Node node) throws GLib.Error;
		public abstract unowned Xml.Node save_to_xml () throws GLib.Error;
	}
	[CCode (cprefix = "GDA_CLIENT_GENERAL_", cheader_filename = "libgda-3.0.h")]
	public enum ClientError {
		ERROR
	}
	[CCode (cprefix = "GDA_CLIENT_EVENT_", cheader_filename = "libgda-3.0.h")]
	public enum ClientEvent {
		INVALID,
		ERROR,
		CONNECTION_OPENED,
		CONNECTION_CLOSED,
		TRANSACTION_STARTED,
		TRANSACTION_COMMITTED,
		TRANSACTION_CANCELLED
	}
	[CCode (cprefix = "GDA_COMMAND_OPTION_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum CommandOptions {
		IGNORE_ERRORS,
		STOP_ON_ERRORS,
		BAD_OPTION
	}
	[CCode (cprefix = "GDA_COMMAND_TYPE_", cheader_filename = "libgda-3.0.h")]
	public enum CommandType {
		SQL,
		XML,
		PROCEDURE,
		TABLE,
		SCHEMA,
		INVALID
	}
	[CCode (cprefix = "GDA_CONNECTION_", cheader_filename = "libgda-3.0.h")]
	public enum ConnectionError {
		CONN_OPEN_ERROR,
		DO_QUERY_ERROR,
		NONEXIST_DSN_ERROR,
		NO_CNC_SPEC_ERROR,
		NO_PROVIDER_SPEC_ERROR,
		OPEN_ERROR,
		EXECUTE_COMMAND_ERROR
	}
	[CCode (cprefix = "GDA_CONNECTION_EVENT_CODE_", cheader_filename = "libgda-3.0.h")]
	public enum ConnectionEventCode {
		CONSTRAINT_VIOLATION,
		RESTRICT_VIOLATION,
		NOT_NULL_VIOLATION,
		FOREIGN_KEY_VIOLATION,
		UNIQUE_VIOLATION,
		CHECK_VIOLATION,
		INSUFFICIENT_PRIVILEGES,
		UNDEFINED_COLUMN,
		UNDEFINED_FUNCTION,
		UNDEFINED_TABLE,
		DUPLICATE_COLUMN,
		DUPLICATE_DATABASE,
		DUPLICATE_FUNCTION,
		DUPLICATE_SCHEMA,
		DUPLICATE_TABLE,
		DUPLICATE_ALIAS,
		DUPLICATE_OBJECT,
		SYNTAX_ERROR,
		UNKNOWN
	}
	[CCode (cprefix = "GDA_CONNECTION_EVENT_", cheader_filename = "libgda-3.0.h")]
	public enum ConnectionEventType {
		NOTICE,
		WARNING,
		ERROR
	}
	[CCode (cprefix = "GDA_CONNECTION_FEATURE_", cheader_filename = "libgda-3.0.h")]
	public enum ConnectionFeature {
		AGGREGATES,
		BLOBS,
		INDEXES,
		INHERITANCE,
		NAMESPACES,
		PROCEDURES,
		SEQUENCES,
		SQL,
		TRANSACTIONS,
		SAVEPOINTS,
		SAVEPOINTS_REMOVE,
		TRIGGERS,
		UPDATABLE_CURSOR,
		USERS,
		VIEWS,
		XML_QUERIES
	}
	[CCode (cprefix = "GDA_CONNECTION_OPTIONS_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum ConnectionOptions {
		NONE,
		READ_ONLY,
		DONT_SHARE
	}
	[CCode (cprefix = "GDA_CONNECTION_SCHEMA_", cheader_filename = "libgda-3.0.h")]
	public enum ConnectionSchema {
		AGGREGATES,
		DATABASES,
		FIELDS,
		INDEXES,
		LANGUAGES,
		NAMESPACES,
		PARENT_TABLES,
		PROCEDURES,
		SEQUENCES,
		TABLES,
		TRIGGERS,
		TYPES,
		USERS,
		VIEWS,
		CONSTRAINTS,
		TABLE_CONTENTS
	}
	[CCode (cprefix = "GDA_DATA_MODEL_ACCESS_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum DataModelAccessFlags {
		RANDOM,
		CURSOR_FORWARD,
		CURSOR_BACKWARD,
		INSERT,
		UPDATE,
		DELETE,
		WRITE
	}
	[CCode (cprefix = "GDA_DATA_MODEL_HINT_", cheader_filename = "libgda-3.0.h")]
	public enum DataModelHint {
		START_BATCH_UPDATE,
		END_BATCH_UPDATE,
		REFRESH
	}
	[CCode (cprefix = "GDA_DATA_MODEL_IO_", cheader_filename = "libgda-3.0.h")]
	public enum DataModelIOFormat {
		DATA_ARRAY_XML,
		TEXT_SEPARATED
	}
	[CCode (cprefix = "GDA_DATA_MODEL_ITER_WHAT_", cheader_filename = "libgda-3.0.h")]
	public enum DataModelIterError {
		ERROR
	}
	[CCode (cprefix = "GDA_DATA_MODEL_QUERY_", cheader_filename = "libgda-3.0.h")]
	public enum DataModelQueryError {
		XML_LOAD_ERROR,
		COMPUTE_MODIF_QUERIES_ERROR
	}
	[CCode (cprefix = "GDA_DATA_MODEL_QUERY_OPTION_USE_ALL_FIELDS_IF_NO_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum DataModelQueryOptions {
		PK
	}
	[CCode (cprefix = "GDA_DATA_PROXY_COMMIT_", cheader_filename = "libgda-3.0.h")]
	public enum DataProxyError {
		ERROR,
		CANCELLED
	}
	[CCode (cprefix = "GDA_DICT_AGGREGATE_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum DictAggregateError {
		ERROR
	}
	[CCode (cprefix = "GDA_DICT_CONSTRAINT_XML_", cheader_filename = "libgda-3.0.h")]
	public enum DictConstraintError {
		SAVE_ERROR,
		LOAD_ERROR
	}
	[CCode (cprefix = "CONSTRAINT_FK_ACTION_", cheader_filename = "libgda-3.0.h")]
	public enum DictConstraintFkAction {
		CASCADE,
		SET_NULL,
		SET_DEFAULT,
		SET_VALUE,
		NO_ACTION
	}
	[CCode (cprefix = "CONSTRAINT_", cheader_filename = "libgda-3.0.h")]
	public enum DictConstraintType {
		PRIMARY_KEY,
		FOREIGN_KEY,
		UNIQUE,
		NOT_NULL,
		CHECK_EXPR,
		CHECK_IN_LIST,
		CHECK_SETOF_LIST,
		UNKNOWN
	}
	[CCode (cprefix = "GDA_DICT_DATABASE_", cheader_filename = "libgda-3.0.h")]
	public enum DictDatabaseError {
		XML_SAVE_ERROR,
		XML_LOAD_ERROR,
		META_DATA_UPDATE,
		META_DATA_UPDATE_USER_STOPPED,
		TABLES_ERROR,
		SEQUENCES_ERROR
	}
	[CCode (cprefix = "GDA_DICT_", cheader_filename = "libgda-3.0.h")]
	public enum DictError {
		META_DATA_UPDATE_ERROR,
		META_DATA_UPDATE_USER_STOPPED,
		LOAD_FILE_NOT_EXIST_ERROR,
		FILE_LOAD_ERROR,
		FILE_SAVE_ERROR,
		DATATYPE_ERROR,
		FUNCTIONS_ERROR,
		AGGREGATES_ERROR
	}
	[CCode (cprefix = "FIELD_AUTO_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum DictFieldAttribute {
		INCREMENT
	}
	[CCode (cprefix = "GDA_DICT_FIELD_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum DictFieldError {
		ERROR
	}
	[CCode (cprefix = "GDA_DICT_FUNCTION_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum DictFunctionError {
		ERROR
	}
	[CCode (cprefix = "GDA_DICT_", cheader_filename = "libgda-3.0.h")]
	public enum DictTableError {
		TABLE_XML_LOAD_ERROR,
		TABLE_META_DATA_UPDATE,
		FIELDS_ERROR
	}
	[CCode (cprefix = "GDA_DICT_TYPE_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum DictTypeError {
		ERROR
	}
	[CCode (cprefix = "GDA_GENERAL_", cheader_filename = "libgda-3.0.h")]
	public enum GeneralError {
		OBJECT_NAME_ERROR,
		INCORRECT_VALUE_ERROR,
		OPERATION_ERROR
	}
	[CCode (cprefix = "GDA_GRAPH_XML_LOAD_", has_type_id = "0", cheader_filename = "libgda-3.0.h")]
	public enum GraphError {
		ERROR
	}
	[CCode (cprefix = "GDA_GRAPH_ITEM_XML_LOAD_", has_type_id = "0", cheader_filename = "libgda-3.0.h")]
	public enum GraphItemError {
		ERROR
	}
	[CCode (cprefix = "GDA_GRAPH_", cheader_filename = "libgda-3.0.h")]
	public enum GraphType {
		DB_RELATIONS,
		QUERY_JOINS,
		MODELLING
	}
	[CCode (cprefix = "GDA_OBJECT_REF_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum ObjectRefError {
		ERROR
	}
	[CCode (cprefix = "REFERENCE_BY_", cheader_filename = "libgda-3.0.h")]
	public enum ObjectRefType {
		XML_ID,
		NAME
	}
	[CCode (cprefix = "GDA_PARAMETER_QUERY_LIMIT_", cheader_filename = "libgda-3.0.h")]
	public enum ParameterError {
		ERROR
	}
	[CCode (cprefix = "GDA_PARAMETER_LIST_", cheader_filename = "libgda-3.0.h")]
	public enum ParameterListError {
		NO_NODE_ERROR,
		NODE_OUTDATED_ERROR,
		VALUE_PROV_OBJ_TYPE_ERROR,
		VALUE_PROV_DATA_TYPE_ERROR,
		VALUE_PROV_INVISIBLE_ERROR,
		VALUE_PROV_QUERY_TYPE_ERROR,
		DEPENDENCY_NOT_IN_PARAMLIST_ERROR,
		DEPENDENCY_POSITION_ERROR,
		XML_SPEC_ERROR
	}
	[CCode (cprefix = "GDA_PARAMETER_LIST_PARAM_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum ParameterListParamHint {
		READ_ONLY,
		HIDE
	}
	[CCode (cprefix = "GDA_QUERY_CONDITION_", cheader_filename = "libgda-3.0.h")]
	public enum QueryConditionError {
		XML_LOAD_ERROR,
		RENDERER_ERROR,
		PARENT_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_CONDITION_OP_", cheader_filename = "libgda-3.0.h")]
	public enum QueryConditionOperator {
		LEFT,
		RIGHT,
		RIGHT2
	}
	[CCode (cprefix = "GDA_QUERY_CONDITION_", cheader_filename = "libgda-3.0.h")]
	public enum QueryConditionType {
		NODE_AND,
		NODE_OR,
		NODE_NOT,
		LEAF_EQUAL,
		LEAF_DIFF,
		LEAF_SUP,
		LEAF_SUPEQUAL,
		LEAF_INF,
		LEAF_INFEQUAL,
		LEAF_LIKE,
		LEAF_SIMILAR,
		LEAF_REGEX,
		LEAF_REGEX_NOCASE,
		LEAF_NOT_REGEX,
		LEAF_NOT_REGEX_NOCASE,
		LEAF_IN,
		LEAF_BETWEEN,
		TYPE_UNKNOWN
	}
	[CCode (cprefix = "GDA_QUERY_", cheader_filename = "libgda-3.0.h")]
	public enum QueryError {
		XML_LOAD_ERROR,
		META_DATA_UPDATE,
		FIELDS_ERROR,
		TARGETS_ERROR,
		RENDER_ERROR,
		PARSE_ERROR,
		SYNTAX_ERROR,
		STRUCTURE_ERROR,
		SQL_ANALYSE_ERROR,
		NO_CNC_ERROR,
		CNC_CLOSED_ERROR,
		EXEC_ERROR,
		PARAM_TYPE_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_AGG_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldAggError {
		XML_LOAD_ERROR,
		RENDER_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_ALL_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldAllError {
		XML_LOAD_ERROR,
		RENDER_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_XML_LOAD_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldError {
		ERROR
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_FIELD_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldFieldError {
		XML_LOAD_ERROR,
		RENDER_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_FUNC_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldFuncError {
		XML_LOAD_ERROR,
		RENDER_ERROR
	}
	[CCode (cprefix = "GDA_ENTITY_FIELD_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum QueryFieldState {
		VISIBLE,
		INVISIBLE,
		ANY
	}
	[CCode (cprefix = "GDA_QUERY_FIELD_VALUE_", cheader_filename = "libgda-3.0.h")]
	public enum QueryFieldValueError {
		XML_LOAD_ERROR,
		RENDER_ERROR,
		PARAM_ERROR,
		DEFAULT_PARAM_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_JOIN_", cheader_filename = "libgda-3.0.h")]
	public enum QueryJoinError {
		XML_LOAD_ERROR,
		META_DATA_UPDATE,
		FIELDS_ERROR,
		SQL_ANALYSE_ERROR,
		PARSE_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_JOIN_TYPE_", cheader_filename = "libgda-3.0.h")]
	public enum QueryJoinType {
		INNER,
		LEFT_OUTER,
		RIGHT_OUTER,
		FULL_OUTER,
		CROSS,
		LAST
	}
	[CCode (cprefix = "GDA_QUERY_TARGET_", cheader_filename = "libgda-3.0.h")]
	public enum QueryTargetError {
		XML_LOAD_ERROR,
		XML_SAVE_ERROR,
		META_DATA_UPDATE,
		FIELDS_ERROR
	}
	[CCode (cprefix = "GDA_QUERY_TYPE_", cheader_filename = "libgda-3.0.h")]
	public enum QueryType {
		SELECT,
		INSERT,
		UPDATE,
		DELETE,
		UNION,
		INTERSECT,
		EXCEPT,
		NON_PARSED_SQL
	}
	[CCode (cprefix = "GDA_RENDERER_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum RendererOptions {
		EXTRA_PRETTY_SQL,
		PARAMS_AS_DETAILED,
		ERROR_IF_DEFAULT,
		FIELDS_NO_TARGET_ALIAS,
		PARAMS_AS_COLON,
		PARAMS_AS_DOLLAR
	}
	[CCode (cprefix = "GDA_SERVER_OPERATION_STATUS_", cheader_filename = "libgda-3.0.h")]
	public enum ServerOperationNodeStatus {
		OPTIONAL,
		REQUIRED,
		UNKNOWN
	}
	[CCode (cprefix = "GDA_SERVER_OPERATION_NODE_", cheader_filename = "libgda-3.0.h")]
	public enum ServerOperationNodeType {
		PARAMLIST,
		DATA_MODEL,
		PARAM,
		SEQUENCE,
		SEQUENCE_ITEM,
		DATA_MODEL_COLUMN,
		UNKNOWN
	}
	[CCode (cprefix = "GDA_SERVER_OPERATION_", cheader_filename = "libgda-3.0.h")]
	public enum ServerOperationType {
		CREATE_DB,
		DROP_DB,
		CREATE_TABLE,
		DROP_TABLE,
		RENAME_TABLE,
		ADD_COLUMN,
		DROP_COLUMN,
		CREATE_INDEX,
		DROP_INDEX,
		NB
	}
	[CCode (cprefix = "GDA_SORTING_", cheader_filename = "libgda-3.0.h")]
	public enum Sorting {
		ASCENDING,
		DESCENDING
	}
	[CCode (cprefix = "GDA_TRANSACTION_ISOLATION_", cheader_filename = "libgda-3.0.h")]
	public enum TransactionIsolation {
		UNKNOWN,
		READ_COMMITTED,
		READ_UNCOMMITTED,
		REPEATABLE_READ,
		SERIALIZABLE
	}
	[CCode (cprefix = "GDA_TRANSACTION_STATUS_EVENT_", cheader_filename = "libgda-3.0.h")]
	public enum TransactionStatusEventType {
		SAVEPOINT,
		SQL,
		SUB_TRANSACTION
	}
	[CCode (cprefix = "GDA_TRANSACTION_STATUS_STATE_", cheader_filename = "libgda-3.0.h")]
	public enum TransactionStatusState {
		OK,
		FAILED
	}
	[CCode (cprefix = "GDA_VALUE_ATTR_", cheader_filename = "libgda-3.0.h")]
	[Flags]
	public enum ValueAttribute {
		NONE,
		IS_NULL,
		CAN_BE_NULL,
		IS_DEFAULT,
		CAN_BE_DEFAULT,
		IS_UNCHANGED,
		ACTIONS_SHOWN,
		DATA_NON_VALID,
		HAS_VALUE_ORIG,
		NO_MODIF,
		UNUSED
	}
	[CCode (cheader_filename = "libgda-3.0.h")]
	public delegate void ConfigListenerFunc (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate unowned Gda.Object DictGetObjFunc (Gda.Dict p1, string p2);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate void DictRegFreeFunc (Gda.Dict p1, Gda.DictRegisterStruct p2);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate unowned Gda.DictRegisterStruct DictRegFunc ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate unowned GLib.SList DictRegGetListFunc (Gda.Dict p1);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate bool DictRegLoadFunc (Gda.Dict p1, Xml.Node p2, GLib.Error p3);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate bool DictRegSaveFunc (Gda.Dict p1, Xml.Node p2, GLib.Error p3);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate bool DictRegSyncFunc (Gda.Dict p1, string limit_object_name, GLib.Error p3);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public delegate void InitFunc ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static delegate void ThreaderFunc (Gda.Threader p1, uint p2, void* p3);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_ERR;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_H0;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_H1;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_H2;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_NOR;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const string D_COL_OK;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const int FUNC_AGG_TEST_PARAMS_DO_TEST;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const int TIMEZONE_INVALID;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public const int TYPE_NULL;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictAggregate aggregates_get_by_dbms_id (Gda.Dict dict, string dbms_id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.SList aggregates_get_by_name (Gda.Dict dict, string aggname);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictAggregate aggregates_get_by_name_arg (Gda.Dict dict, string aggname, Gda.DictType argtype);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictAggregate aggregates_get_by_name_arg_in_list (Gda.Dict dict, GLib.SList aggregates, string aggname, Gda.DictType argtype);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictRegisterStruct aggregates_get_register ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static uint config_add_listener (string path, Gda.ConfigListenerFunc func);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_can_modify_global_config ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DataSourceInfo config_find_data_source (string name);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_free_data_source_list (GLib.List list);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_free_list (GLib.List list);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_free_provider_list (GLib.List list);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_get_boolean (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.List config_get_data_source_list ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DataModel config_get_data_source_model ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static double config_get_float (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static int config_get_int (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.ProviderInfo config_get_provider_by_name (string name);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.List config_get_provider_list ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DataModel config_get_provider_model ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string config_get_string (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string config_get_type (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_has_key (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_has_section (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.List config_list_keys (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.List config_list_sections (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_remove_data_source (string name);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_remove_key (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_remove_listener (uint id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void config_remove_section (string path);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_save_data_source (string name, string provider, string cnc_string, string description, string username, string password, bool is_global);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_save_data_source_info (Gda.DataSourceInfo dsn_info);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_set_boolean (string path, bool new_value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_set_float (string path, double new_value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_set_int (string path, int new_value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool config_set_string (string path, string new_value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool create_table (Gda.Connection cnn, string table_name) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string default_escape_string (string str);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string default_unescape_string (string str);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool delete_row_from_table (Gda.Connection cnn, string table_name, string condition_column_name, GLib.Value condition) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool drop_table (Gda.Connection cnn, string table_name) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DataModel execute_select_command (Gda.Connection cnn, string sql) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static int execute_sql_command (Gda.Connection cnn, string sql) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string file_load (string filename);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool file_save (string filename, string buffer, int len);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictFunction functions_get_by_dbms_id (Gda.Dict dict, string dbms_id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.SList functions_get_by_name (Gda.Dict dict, string aggname);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictFunction functions_get_by_name_arg (Gda.Dict dict, string aggname, GLib.SList argtypes);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictFunction functions_get_by_name_arg_in_list (Gda.Dict dict, GLib.SList functions, string aggname, GLib.SList argtypes);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictRegisterStruct functions_get_register ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Type g_type_from_string (string str);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string g_type_to_string (GLib.Type type);
	[CCode (cname = "g_types_get_register", cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictRegisterStruct g_types_get_register ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Quark general_error_quark ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Dict get_default_dict ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void graphs_declare_serial (Gda.DictRegisterStruct reg, uint id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Graph graphs_get_graph_for_object (Gda.Dict dict, GLib.Object obj);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictRegisterStruct graphs_get_register ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static uint graphs_get_serial (Gda.DictRegisterStruct reg);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.SList graphs_get_with_type (Gda.Dict dict, Gda.GraphType type_of_graphs);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void init (string app_id, string version, int nargs, string[] args);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool insert_row_into_table (Gda.Connection cnn, string table_name) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool insert_row_into_table_from_string (Gda.Connection cnn, string table_name) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void log_disable ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void log_enable ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void log_error (string format);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool log_is_enabled ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void log_message (string format);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void main_quit ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void main_run (Gda.InitFunc init_func);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_BOOLEAN__INT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_BOOLEAN__INT_INT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__ENUM_OBJECT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__INT_BOOLEAN (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__INT_BOXED_BOXED (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__INT_INT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__OBJECT_ENUM_OBJECT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__OBJECT_OBJECT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__OBJECT_UINT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__OBJECT_UINT_UINT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__STRING_INT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void marshal_VOID__STRING_UINT_UINT (GLib.Closure closure, GLib.Value return_value, uint n_param_values, GLib.Value param_values, void* invocation_hint, void* marshal_data);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Connection open_connection (string dsn, string username, string password, Gda.ConnectionOptions options) throws GLib.Error;
	[CCode (cname = "parsed_create_complex_condition", cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.QueryCondition parsed_create_complex_condition (Gda.Query query, Gda.ParseData pdata, SQL.Where where, bool try_existing_field, GLib.SList targets_return) throws GLib.Error;
	[CCode (cname = "parsed_create_delete_query", cheader_filename = "libgda-3.0.h")]
	public static bool parsed_create_delete_query (Gda.Query query, SQL.DeleteStatement del) throws GLib.Error;
	[CCode (cname = "parsed_create_global_query_field", cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.EntityField parsed_create_global_query_field (Gda.Query query, bool add_to_query, Gda.ParseData pdata, SQL.Field field, bool try_existing_field, bool new_field, out unowned Gda.QueryTarget target_return) throws GLib.Error;
	[CCode (cname = "parsed_create_insert_query", cheader_filename = "libgda-3.0.h")]
	public static bool parsed_create_insert_query (Gda.Query query, SQL.InsertStatement insert) throws GLib.Error;
	[CCode (cname = "parsed_create_select_query", cheader_filename = "libgda-3.0.h")]
	public static bool parsed_create_select_query (Gda.Query query, SQL.SelectStatement select) throws GLib.Error;
	[CCode (cname = "parsed_create_update_query", cheader_filename = "libgda-3.0.h")]
	public static bool parsed_create_update_query (Gda.Query query, SQL.UpdateStatement update) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void queries_declare_serial (Gda.DictRegisterStruct reg, uint id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictRegisterStruct queries_get_register ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static uint queries_get_serial (Gda.DictRegisterStruct reg);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Type short_get_type ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned GLib.List string_hash_to_list (GLib.HashTable hash_table);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool string_to_binary (string str, Gda.Binary bin);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool string_to_blob (string str, Gda.Blob blob);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool update_value_in_table (Gda.Connection cnn, string table_name, string search_for_column, GLib.Value condition, string column_name, GLib.Value new_value) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool update_values_in_table (Gda.Connection cnn, string table_name, string condition_column_name, GLib.Value condition) throws GLib.Error;
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Type ushort_get_type ();
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string utility_build_decoded_id (string prefix, string id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string utility_build_encoded_id (string prefix, string id);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool utility_check_data_model (Gda.DataModel model, int nbcols);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void utility_data_model_dump_data_to_xml (Gda.DataModel model, Xml.Node parent, int cols, int nb_cols, int rows, int nb_rows, bool use_col_ids);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.DictType utility_find_or_create_data_type (Gda.Dict dict, Gda.ServerProvider prov, Gda.Connection cnc, string dbms_type, string g_type, bool created);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void utility_parameter_load_attributes (Gda.Parameter param, Xml.Node node, GLib.SList sources);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static uint utility_table_field_attrs_parse (string str);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string utility_table_field_attrs_stringify (Gda.ValueAttribute attributes);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static int value_compare (GLib.Value value1, GLib.Value value2);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static int value_compare_ext (GLib.Value value1, GLib.Value value2);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_copy (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_free (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Binary value_get_binary (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Blob value_get_blob (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.GeometricPoint value_get_geometric_point (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.ValueList value_get_list (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Numeric value_get_numeric (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static short value_get_short (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Time value_get_time (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Gda.Timestamp value_get_timestamp (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static ushort value_get_ushort (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool value_is_null (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool value_is_number (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new (GLib.Type type);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new_binary (uchar[] val, long size);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new_blob (uchar[] val, long size);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new_from_string (string as_string, GLib.Type type);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new_from_xml (Xml.Node node);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static GLib.Value value_new_timestamp_from_timet (ulong val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_reset_with_type (GLib.Value value, GLib.Type type);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_binary (GLib.Value value, Gda.Binary binary);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_blob (GLib.Value value, Gda.Blob blob);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool value_set_from_string (GLib.Value value, string as_string, GLib.Type type);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static bool value_set_from_value (GLib.Value value, GLib.Value from);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_geometric_point (GLib.Value value, Gda.GeometricPoint val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_list (GLib.Value value, Gda.ValueList val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_null (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_numeric (GLib.Value value, Gda.Numeric val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_short (GLib.Value value, short val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_time (GLib.Value value, Gda.Time val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_timestamp (GLib.Value value, Gda.Timestamp val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_set_ushort (GLib.Value value, ushort val);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned string value_stringify (GLib.Value value);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_take_binary (GLib.Value value, Gda.Binary binary);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static void value_take_blob (GLib.Value value, Gda.Blob blob);
	[CCode (cheader_filename = "libgda-3.0.h")]
	public static unowned Xml.Node value_to_xml (GLib.Value value);
}
